# << Haru Free PDF Library 2.0.0 >> -- arc_demo.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf

set pdf [hpdf::new]

set page [$pdf addPage]

$page setHeight 220
$page setWidth 200

# draw pie chart
# A: 45% Red
# B: 25% Blue
# C: 15% green
# D: other yellow

# A
$page setRGBFill 1.0 0.0 0.0
$page moveTo 100 100
$page lineTo 100 180
$page arc 100 100 80 0 [expr {360 * 0.45}]
set pos [$page getCurrentPos]
$page lineTo 100 100
$page fill

# B
$page setRGBFill 0.0 0.0 1.0
$page moveTo 100 100
$page lineTo [lindex $pos 0] [lindex $pos 1]
$page arc 100 100 80 [expr {360 * 0.45}] [expr {360 * 0.7}]
set pos [$page getCurrentPos]
$page lineTo 100 100
$page fill

# C
$page setRGBFill 0.0 1.0 0.0
$page moveTo 100 100
$page lineTo [lindex $pos 0] [lindex $pos 1]
$page arc 100 100 80 [expr {360 * 0.7}] [expr {360 * 0.85}]
set pos [$page getCurrentPos]
$page lineTo 100 100
$page fill

# D
$page setRGBFill 1.0 1.0 0.0
$page moveTo 100 100
$page lineTo [lindex $pos 0] [lindex $pos 1]
$page arc 100 100 80 [expr {360 * 0.85}] 360
set pos [$page getCurrentPos]
$page lineTo 100 100
$page fill

# draw center circle
$page setGrayStroke 0
$page setGrayFill 1
$page circle 100 100 30
$page fill

$pdf saveToFile [file rootname [info script]].pdf

hpdf::free $pdf
