# << Haru Free PDF Library 2.0.0 >> -- font_demo.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf

set font_list {
    "Courier" 
    "Courier-Bold" 
    "Courier-Oblique" 
    "Courier-BoldOblique"
    "Helvetica"
    "Helvetica-Bold"
    "Helvetica-Oblique"
    "Helvetica-BoldOblique"
    "Times-Roman"
    "Times-Bold"
    "Times-Italic"
    "Times-BoldItalic"
    "Symbol"
    "ZapfDingbats"
}

set pdf [hpdf::new]
set page [$pdf addPage]
set height [$page getHeight]
set width [$page getWidth]

$page setLineWidth 1.0
$page rectangle 50.0 50.0 [expr $width - 100] [expr $height - 110]
$page stroke

set font1 [$pdf getFont "Helvetica" ""]

set title "Font Example"
$page setFontAndSize $font1 24.0
set tw [$page textWidth $title]
$page beginText
$page textOut [expr ($width - $tw)/2] [expr $height - 50.0] $title
$page setFontAndSize $font1 16.0
$page textOut 60 [expr $height - 80.0] "<Standard Type1 fonts samples>"
$page endText

set samp_text {abcdefgABCDEFG12345!#$\%&+-@?}

$page beginText
$page moveTextPos 60.0 [expr $height - 105.0]

foreach font $font_list {
    set font2 [$pdf getFont $font ""]
    
    $page setFontAndSize $font1 9.0
    $page showText $font
    $page moveTextPos 0.0 -18.0

    $page setFontAndSize $font2 20.0
    $page showText $samp_text
    $page moveTextPos 0.0 -20
}

$page endText
$pdf saveToFile [file rootname [info script]].pdf
