# << Haru Free PDF Library 2.0.0 >> -- jpeg_demo.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf


proc draw_image {pdf filename x y text} {
    set page [$pdf getCurrentPage]

    set image [$pdf loadJpegImageFromFile \
        [file join images $filename]]

    # Draw image to the canvas.
    $page drawImage $image $x $y \
        [$image getWidth] \
        [$image getHeight]

    # Print the text.
    $page beginText
    $page setTextLeading 16
    $page moveTextPos $x $y
    $page showTextNextLine $filename
    $page showTextNextLine $text
    $page endText
}

proc main {} {
    set pdf [hpdf::new]
    
    $pdf setCompressionMode all

    # create default-font
    set font [$pdf getFont "Helvetica"]


    # add a new page object.
    set page [$pdf addPage]

    $page setWidth 650
    $page setHeight 500

    set dst [$page createDestination]
    $dst setXYZ 0 [$page getHeight] 1
    $pdf setOpenAction $dst

    $page beginText
    $page setFontAndSize $font 20
    $page moveTextPos 220 [expr {[$page getHeight] - 70}]
    $page showText "JpegDemo"
    $page endText

    $page setFontAndSize $font 12

    draw_image $pdf "rgb.jpg" 70 \
        [expr {[$page getHeight] - 410}] \
        "24bit color image"
    draw_image $pdf "gray.jpg" 340 \
        [expr {[$page getHeight] - 410}] \
        "8bit grayscale image"

    # save the document to a file
    $pdf saveToFile [file rootname [info script]].pdf

    # clean up 
    hpdf::free $pdf

    return 0;
}

main
