# << Haru Free PDF Library 2.0.0 >> -- permission.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf

set text "User cannot print and copy this document."
set owner_passwd "owner"
set user_passwd ""

set pdf [hpdf::new]

# create default-font
set font [$pdf getFont "Helvetica"]

# add a new page object.
set page [$pdf addPage]

$page setSize b5 landscape

$page beginText
$page setFontAndSize $font 20
set tw [$page textWidth $text]
$page moveTextPos \
    [expr {([$page getWidth] - $tw) / 2}] \
    [expr {([$page getHeight] - 20) / 2}]
$page showText $text
$page endText

$pdf setPassword $owner_passwd $user_passwd
$pdf setPermission read
$pdf setEncryptionMode r3 16

# save the document to a file
$pdf saveToFile [file rootname [info script]].pdf

# clean up
hpdf::free $pdf

exit
