# << Haru Free PDF Library 2.0.0 >> -- png_demo.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf


proc draw_image {pdf filename x y text} {
    set page [$pdf getCurrentPage]
    set image [$pdf loadPngImageFromFile "pngsuite/$filename"]
    # Draw image to the canvas.
    $page drawImage $image $x $y \
        [$image getWidth] \
        [$image getHeight]

    # Print the text.
    $page beginText
    $page setTextLeading 16
    $page moveTextPos $x $y
    $page showTextNextLine $filename
    $page showTextNextLine $text
    $page endText
}

proc main {} {
    set pdf [hpdf::new]

    $pdf setCompressionMode all

    # create default-font
    set font [$pdf getFont "Helvetica"]

    # add a new page object.
    set page [$pdf addPage]

    $page setWidth 550
    $page setHeight 650

    set dst [$page createDestination]
    $dst setXYZ 0 [$page getHeight] 1
    $pdf setOpenAction $dst

    $page beginText
    $page setFontAndSize $font 20
    $page moveTextPos 220 [expr {[$page getHeight] - 70}]
    $page showText "PngDemo"
    $page endText

    $page setFontAndSize $font 12

    draw_image $pdf "basn0g01.png" 100 \
        [expr {[$page getHeight] - 150}] "1bit grayscale."
    draw_image $pdf "basn0g02.png" 200 \
        [expr {[$page getHeight] - 150}] "2bit grayscale."
    draw_image $pdf "basn0g04.png" 300 \
        [expr {[$page getHeight] - 150}] "4bit grayscale."
    draw_image $pdf "basn0g08.png" 400 \
        [expr {[$page getHeight] - 150}] "8bit grayscale."
    draw_image $pdf "basn2c08.png" 100 \
        [expr {[$page getHeight] - 250}] "8bit color."
    draw_image $pdf "basn2c16.png" 200 \
        [expr {[$page getHeight] - 250}] "16bit color."
    draw_image $pdf "basn3p01.png" 100 \
        [expr {[$page getHeight] - 350}] "1bit pallet."
    draw_image $pdf "basn3p02.png" 200 \
        [expr {[$page getHeight] - 350}] "2bit pallet."
    draw_image $pdf "basn3p04.png" 300 \
        [expr {[$page getHeight] - 350}] "4bit pallet."
    draw_image $pdf "basn3p08.png" 400 \
        [expr {[$page getHeight] - 350}] "8bit pallet."
    draw_image $pdf "basn4a08.png" 100 \
        [expr {[$page getHeight] - 450}] "8bit alpha."
    draw_image $pdf "basn4a16.png" 200 \
        [expr {[$page getHeight] - 450}] "16bit alpha."
    draw_image $pdf "basn6a08.png" 100 \
        [expr {[$page getHeight] - 550}] "8bit alpha."
    draw_image $pdf "basn6a16.png" 200 \
        [expr {[$page getHeight] - 550}] "16bit alpha."

    # save the document to a file
    $pdf saveToFile [file rootname [info script]].pdf

    # clean up
    hpdf::free $pdf

    return 0
}


main
exit
