# << Haru Free PDF Library 2.0.0 >> -- raw_image_demo.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf

set RAW_IMAGE_DATA "\xff\xff\xff\xfe\xff\xff\xff\xfc\xff\xff\xff\xf8\xff\xff\xff\xf0\xf3\xf3\xff\xe0\xf3\xf3\xff\xc0\xf3\xf3\xff\x80\xf3\x33\xff\x00\xf3\x33\xfe\x00\xf3\x33\xfc\x00\xf8\x07\xf8\x00\xf8\x07\xf0\x00\xfc\xcf\xe0\x00\xfc\xcf\xc0\x00\xff\xff\x80\x00\xff\xff\x00\x00\xff\xfe\x00\x00\xff\xfc\x00\x00\xff\xf8\x0f\xe0\xff\xf0\x0f\xe0\xff\xe0\x0c\x30\xff\xc0\x0c\x30\xff\x80\x0f\xe0\xff\x00\x0f\xe0\xfe\x00\x0c\x30\xfc\x00\x0c\x30\xf8\x00\x0f\xe0\xf0\x00\x0f\xe0\xe0\x00\x00\x00\xc0\x00\x00\x00\x80\x00\x00\x00\x00\x00\x00\x00"


set pdf [hpdf::new]

$pdf setCompressionMode all

# create default-font
set font [$pdf getFont "Helvetica"]

# add a new page object.
set page [$pdf addPage]

$page setWidth 172
$page setHeight 80

$page beginText
$page setFontAndSize $font 20
$page moveTextPos 220 [expr {[$page getHeight]- 70}]
$page showText "RawImageDemo"
$page endText

# load RGB raw-image file.
set image [$pdf loadRawImageFromFile \
    "rawimage/32_32_rgb.dat" 32 32 rgb]

set x 20
set y 20

# Draw image to the canvas. (normal-mode with actual size.)
$page drawImage $image $x $y 32 32

# load GrayScale raw-image file.
set image [$pdf loadRawImageFromFile \
    "rawimage/32_32_gray.dat" 32 32 gray]

set x 70
set y 20

# Draw image to the canvas. (normal-mode with actual size.)
$page drawImage $image $x $y 32 32

# load GrayScale raw-image (1bit) file from memory.
set image [$pdf loadRawImageFromMem \
    $RAW_IMAGE_DATA 32 32 gray 1]

set x 120
set y 20

# Draw image to the canvas. (normal-mode with actual size.)
$page drawImage $image $x $y 32 32

# save the document to a file
$pdf saveToFile [file rootname [info script]].pdf

# clean up
hpdf::free $pdf

exit
