# << Haru Free PDF Library 2.0.0 >> -- text_annotation.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf

set rect1 {50 350 150 400}
set rect2 {210 350 350 400}
set rect3 {50 250 150 300}
set rect4 {210 250 350 300}
set rect5 {50 150 150 200}
set rect6 {210 150 350 200}
set rect7 {50 50 150 100}
set rect8 {210 50 350 100}

set pdf [hpdf::new]

#  use Times-Roman font.
set font [$pdf getFont "Times-Roman" "WinAnsiEncoding"]

set page [$pdf addPage]

$page setWidth 400
$page setHeight 500

$page beginText
$page setFontAndSize $font 16
$page moveTextPos 130 450
$page showText "Annotation Demo"
$page endText

set annot [$page createTextAnnot $rect1 "Annotation with Comment Icon. \n This annotation set to be opened initially." ""]

$annot setIcon comment
$annot setOpened yes

set annot [$page createTextAnnot $rect2 \
                "Annotation with Key Icon" ""]
$annot setIcon paragraph

set annot [$page createTextAnnot $rect3 \
                "Annotation with Note Icon" ""]
$annot setIcon note

set annot [$page createTextAnnot $rect4 \
                "Annotation with Help Icon" ""]
$annot setIcon help

set annot [$page createTextAnnot $rect5 \
            "Annotation with NewParagraph Icon" ""]
$annot setIcon new_paragraph

set annot [$page createTextAnnot $rect6 \
                "Annotation with Paragraph Icon" ""]
$annot setIcon paragraph

set annot [$page createTextAnnot $rect7 \
                "Annotation with Insert Icon" ""]
$annot setIcon insert

set encoding [$pdf getEncoder "ISO8859-2"]

# use Times-Roman font.
set font [$pdf getFont "Times-Roman" "WinAnsiEncoding"]

set page [$pdf addPage]

$page setWidth 400
$page setHeight 500

$page beginText
$page setFontAndSize $font 16
$page moveTextPos 130 450
$page showText "Annotation Demo"
$page endText


set annot [$page createTextAnnot $rect1 \
                "Annotation with Comment Icon. \n This annotation set to be opened initially." ""]

$annot setIcon comment
$annot setOpened yes

set annot [$page createTextAnnot $rect2 \
                "Annotation with Key Icon" ""]
$annot setIcon paragraph

set annot [$page createTextAnnot $rect3 \
                "Annotation with Note Icon" ""]
$annot setIcon note

set annot [$page createTextAnnot $rect4 \
                "Annotation with Help Icon" ""]
$annot setIcon help

set annot [$page createTextAnnot $rect5 \
                "Annotation with NewParagraph Icon" ""]
$annot setIcon new_paragraph

set annot [$page createTextAnnot $rect6 \
                "Annotation with Paragraph Icon" ""]
$annot setIcon paragraph

set annot [$page createTextAnnot $rect7 \
                "Annotation with Insert Icon" ""]
$annot setIcon insert

set encoding [$pdf getEncoder "ISO8859-2"]

set enc [encoding system]
encoding system iso8859-2
$page createTextAnnot $rect8 \
                "Annotation with ISO8859 text \xd3\xd4\xd5\xd6\xd7\xd8" $encoding
encoding system $enc

$page setFontAndSize $font 11

$page beginText
$page moveTextPos \
    [expr {[lindex $rect1 0] + 35}] \
    [expr {[lindex $rect1 3] - 20}]
$page showText "Comment Icon."
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect2 0] + 35}] \
    [expr {[lindex $rect2 3] - 20}]
$page showText "Key Icon."
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect3 0] + 35}] \
    [expr {[lindex $rect3 3] - 20}]
$page showText "Note Icon."
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect4 0] + 35}] \
    [expr {[lindex $rect4 3] - 20}]
$page showText "Help Icon"
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect5 0] + 35}] \
    [expr {[lindex $rect5 3] - 20}]
$page showText "NewParagraph Icon"
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect6 0] + 35}] \
    [expr {[lindex $rect6 3] - 20}]
$page showText "Paragraph Icon"
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect7 0] + 35}] \
    [expr {[lindex $rect7 3] - 20}]
$page showText "Insert Icon"
$page endText

$page beginText
$page moveTextPos \
    [expr {[lindex $rect8 0] + 35}] \
    [expr {[lindex $rect8 3] - 20}]
$page showText "Text Icon(ISO8859-2 text)"
$page endText

# save the document to a file
$pdf saveToFile [file rootname [info script]].pdf

# clean up
hpdf::free $pdf

exit
