# << Haru Free PDF Library 2.0.0 >> -- ttfont_demo_jp.tcl
#
# Copyright (c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# Copyright (c) 2007      Yoshio Ohtsuka <ohtsuka.yosio@gmail.com>
#
# Permission to use, copy, modify, distribute and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation.
# It is provided "as is" without express or implied warranty.

lappend auto_path ..
package require Hpdf


if {$argc < 1} {
    puts {usage: ttfont_demo_jp <ttf-font-filename> [-E]}
    puts {usage: ttfont_demo_jp <ttf-font-filename> <index> [-E]}
    exit 1
}

if {[catch {open "mbtext/sjis.txt"} fp]} {
    puts "error: cannot open 'mbtext/sjis.txt'"
    exit 1
}
set SAMP_TXT [read $fp]
close $fp

set pdf [hpdf::new]

# declaration for using Japanese encoding.
$pdf useJPEncodings

$pdf setCompressionMode all

#load ttc file
if {$argc == 3 && [lindex $argv 2] eq "-E"} {
    set detail_font_name [$pdf loadTTFontFromFile2 \
        [lindex $argv 0] [lindex $argv 1] yes]
} elseif {$argc == 2 && [lindex $argv 1] eq "-E"} {
    set detail_font_name [$pdf loadTTFontFromFile [lindex $argv 0] yes]
} elseif {$argc == 2} {
    set detail_font_name [$pdf loadTTFontFromFile2 \
        [lindex $argv 0] [lindex $argv 1] no]
} else {
    set detail_font_name [$pdf loadTTFontFromFile [lindex $argv 0] no]
}


# add a new page object.
set page [$pdf addPage]

set title_font [$pdf getFont "Helvetica"]

set detail_font [$pdf getFont $detail_font_name "90msp-RKSJ-H"]

$page setFontAndSize $title_font 10

$page beginText

# move the position of the text to top of the page.
$page moveTextPos 10 190
$page showText $detail_font_name
$page showText " ("
$page showText [$detail_font getEncodingName]
$page showText ")"

$page setFontAndSize $detail_font 15
$page moveTextPos 10 -20
$page showText "abcdefghijklmnopqrstuvwxyz"
$page moveTextPos 0 -20
$page showText "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
$page moveTextPos 0 -20
$page showText "1234567890"
$page moveTextPos 0 -20

$page setFontAndSize $detail_font 10
$page showText $SAMP_TXT
$page moveTextPos 0 -18

$page setFontAndSize $detail_font 16
$page showText $SAMP_TXT
$page moveTextPos 0 -27

$page setFontAndSize $detail_font 23
$page showText $SAMP_TXT
$page moveTextPos 0 -36

$page setFontAndSize $detail_font 30
$page showText $SAMP_TXT
$page moveTextPos 0 -36

set pw [$page textWidth $SAMP_TXT]
set page_height 210
set page_width [expr {$pw + 40}]

$page setWidth $page_width
$page setHeight $page_height

# finish to print text.
$page endText

$page setLineWidth 0.5

$page moveTo 10 [expr {$page_height - 25}]
$page lineTo [expr {$page_width - 10}] [expr {$page_height - 25}]
$page stroke 

$page moveTo 10 [expr {$page_height - 85}]
$page lineTo [expr {$page_width - 10}] [expr {$page_height - 85}]
$page stroke 

$pdf saveToFile [file rootname [info script]].pdf

hpdf::free $pdf
exit
