[manpage_begin tclhpdfDoc 1 0.1.0]
[copyright {1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>}]
[copyright {2007 OHTSUKA, yoshio <ohtsuka.yoshio@gmail.com>}]
[moddesc   {tclhpdf Doc Handler}]
[description]
The Doc handler command have subcommands to control pdf document.

[usage COMMANDS]
[section COMMANDS]
[list_begin definitions]
[call [cmd hpdfDocObj] [method newDoc]]
newDoc creates new document. If document object already has a document, the current document is revoked.
[call [cmd hpdfDocObj] [method freeDoc]]
[call [cmd hpdfDocObj] [method freeDocAll]]
freeDoc, freeDocAll revokes the current document. freeDoc keeps loaded resource (such as fonts and encodings) and these resources are recycled when new document required these resources. freeDocAll revokes the current document and all resources.
[call [cmd hpdfDocObj] [method hasDoc]]
hasDoc returns 1, if current document object has valid document.
[call [cmd hpdfDocObj] [method saveToStream]]
saveToStream saves the current document to a temporary stream of a document object.
[call [cmd hpdfDocObj] [method getStreamSize]]
getStreamSize gets the size of the temporary stream of the document.
[call [cmd hpdfDocObj] [method readFromStream]]
readFromStream copies the data from the temporary stream of the document into the buffer.
[call [cmd hpdfDocObj] [method resetStream]]
resetStream rewinds the temporary stream of the document.
[call [cmd hpdfDocObj] [method saveToFile] [arg filename]]
saveToFile saves the current document to a file.
[call [cmd hpdfDocObj] [method setPagesConfiguration] [arg page_par_pages]]
In the default setting, a doc object has one "Pages" object as root of pages. All "Page" objects are created as a kid of the "Pages" object.
Since a "Pages" object can own only 8191 kids objects, the maximum number of pages are 8191 page.
[para]
Additionally, the state that there are a lot of  "Page" object under one "Pages" object is not good, because it causes performance degradation of  a viewer application.
[para]
An application can change the setting of a pages tree by invoking setPagesConfiguration. If [arg [const page_per_pages]] parameter is set to more than zero, a two-tier pages tree is created. A root "Pages" object can own 8191 "Pages" object, and each lower "Pages" object can own [arg page_per_pages] "Page" objects. As a result, the maximum number of pages becomes 8191 * [arg page_per_pages] page.
[para]
An application cannot invoke setPageConfiguration after a page is added to document.
[call [cmd hpdfDocObj] [method getPageLayout]]
getPageLayout returns the current setting for page layout.
[call [cmd hpdfDocObj] [method setPageLayout] [arg layout]]
setPageLayout sets how the page should be displayed. If this attribute is not set, the setting of a viewer application is used.
[para]
The following values are available for [arg [const layout]].
[list_begin definitions]
    [def [const single]]
    Only one page is displayed.
    [def [const one_column]]
    Display the pages in one column.
    [def [const two_column_left]]
    Display the pages in two column.
    The page of the odd number is displayed left.
    [def [const two_column_right]]
    Display the pages in two column.
    The page of the odd number is displayed right.
[list_end]

[call [cmd hpdfDocObj] [method getPageMode]]
getPageMode returns the current setting for page mode.

[call [cmd hpdfDocObj] [method setPageMode] [arg mode]]
setPageMode sets how the document should be displayed.
[para]
The following values are available for [arg [const mode]].
[list_begin definitions]
    [def [const none]]
    Display the document with neither outline nor thumbnail.
    [def [const outline]]
    Display the document with outline pain.
    [def [const thumbs]]
    Display the document with thumbnail pain.
    [def [const fullscreen]]
    Display the document with full screen mode. 
[list_end]

[call [cmd hpdfDocObj] [method getViewerPreference]]
getViewerPreference gets pdf viewer preference setting.

[call [cmd hpdfDocObj] [method setViewerPreference] [arg flags]]
setViewerPreference sets pdf viewer preference setting.
[para]
The following values are available for [arg [const flags]].
[list_begin definitions]
    [def [const hide_toolbar]]
    Hide pdf viewer toolbar.
    [def [const hide_menubar]]
    Hide pdf viewer menubar.
    [def [const hide_window_ui]]
    Hide pdf viewer window ui.
    [def [const fit_window]]
    Fit pdf viewer window.
    [def [const center_window]]
    Move pdf viewer window center.
[list_end]

[call [cmd hpdfDocObj] [method setOpenAction] [arg hpdfDestinationObj]]
setOpenAction set the first page appears when a document is opened.

[call [cmd hpdfDocObj] [method getPageByIndex] [arg index]]
getPageByIndex returns the handle of a page object by pecified index.

[call [cmd hpdfDocObj] [method getCurrentPage]]
getPageLayout returns the handle of current page object.

[call [cmd hpdfDocObj] [method addPage]]
addPage creates a new page and adds it after the last page of a document. It returns the handle of a new page object.

[call [cmd hpdfDocObj] [method insertPage] [arg hpdfPageObj]]
insertPage creates a new page and inserts it just before the specified page. It returns the handle of a new page object.

[call [cmd hpdfDocObj] [method getFont] [arg fontname] ?[arg encodingname]?]
getFont gets the handle of a corresponding font object by specified name and encoding. It returns hpdfFontObj.
See also "Fonts and Encodings" in original libharu document.

[call [cmd hpdfDocObj] [method loadType1FontFromFile] [arg afmfilename] [arg pfmfilename]]
loadType1FontFromFile loads a type1 font from an external file and register it to a document object. It returns hpdfFontObj.
See also "Fonts and Encodings" in original libharu document.

[call [cmd hpdfDocObj] [method loadTTFontFromFile] [arg filename] [arg embedding]]
loadTTFontFromFile loads a TrueType font from an external file and register it to a document object. It returns hpdfFontObj.
See also "Fonts and Encodings" in original libharu document.

[call [cmd hpdfDocObj] [method loadTTFontFromFile2] [arg filename] [arg index] [arg embedding]]
loadTTFontFromFile2 loads a TrueType font from an TrueType collection file and register it to a document object. It returns hpdfFontObj.
See also "Fonts and Encodings" in original libharu document.

[call [cmd hpdfDocObj] [method addPageLabel] [arg pagenum] [arg style] [arg firstpage] [arg prefix]]
addPageLabel adds a page labeling range for the document.
[para]
The following values are available for [arg [const style]].
[list_begin definitions]
    [def [const decimal]]
	Page label is displayed by Arabic numerals.
    [def [const upper_roman]]
	Page label is displayed by Uppercase roman numerals.
    [def [const lower_roman]]
	Page label is displayed by Lowercase roman numerals.
    [def [const upper_letters]]
	Page label is displayed by Uppercase letters (using A to Z).
    [def [const lower_letters]]
	Page label is displayed by Lowercase letters (using a to z).
[list_end]

[call [cmd hpdfDocObj] [method useJPFonts]]
useJPFonts enables Japanese fonts. After useJPFonts is involed, an application can use the following Japanese fonts.
[list_begin item]
    [item] MS-Mincyo
    [item] MS-Mincyo,Bold
    [item] MS-Mincyo,Italic
    [item] MS-Mincyo,BoldItalic
    [item] MS-Gothic
    [item] MS-Gothic,Bold
    [item] MS-Gothic,Italic
    [item] MS-Gothic,BoldItalic
    [item] MS-PMincyo
    [item] MS-PMincyo,Bold
    [item] MS-PMincyo,Italic
    [item] MS-PMincyo,BoldItalic
    [item] MS-PGothic
    [item] MS-PGothic,Bold
    [item] MS-PGothic,Italic
    [item] MS-PGothic,BoldItalic
[list_end]

[call [cmd hpdfDocObj] [method useKRFonts]]
useKRFonts enables Korean fonts. After useKRFonts is involed, an application can use the following Korean fonts.
[list_begin item]
    [item] DotumChe
    [item] DotumChe,Bold
    [item] DotumChe,Italic
    [item] DotumChe,BoldItalic
    [item] Dotum
    [item] Dotum,Bold
    [item] Dotum,Italic
    [item] Dotum,BoldItalic
    [item] BatangChe
    [item] BatangChe,Bold
    [item] BatangChe,Italic
    [item] BatangChe,BoldItalic
    [item] Batang
    [item] Batang,Bold
    [item] Batang,Italic
    [item] Batang,BoldItalic
[list_end]

[call [cmd hpdfDocObj] [method useCNSFonts]]
useCNSFonts enables simplified Chinese fonts. After useCNSFonts is involed, an application can use the following simplified Chinese fonts.
[list_begin item]
    [item] SimSun
    [item] SimSun,Bold
    [item] SimSun,Italic
    [item] SimSun,BoldItalic
    [item] SimHei
    [item] SimHei,Bold
    [item] SimHei,Italic
    [item] SimHei,BoldItalic
[list_end]

[call [cmd hpdfDocObj] [method useCNTFonts]]
useCNTFonts enables traditional Chinese fonts. After useCNTFonts is involed, an application can use the following traditional Chinese fonts.
[list_begin item]
    [item] MingLiU
    [item] MingLiU,Bold
    [item] MingLiU,Italic
    [item] MingLiU,BoldItalic
[list_end]

[call [cmd hpdfDocObj] [method createOutline] [arg parent] [arg title] ?[arg encoder]?]
createOutline creates a new outline object and returns it.
[para]
[arg [const parent]] is the handle of an outline object which comes to the parent of the created outline object. If this parameter is empty string, The outline is created as a root outline.
[arg [const title]] is the caption of the outline object.
[arg [const encoder]] is the handle of an encoding object applied to the title. If empty string is set or omitted, default value is used.

[call [cmd hpdfDocObj] [method getEncoder] [arg encodingname]]
getEncoder gets the handle of a corresponding encoder object by specified encoding name.
See also "Fonts and Encodings" in original libharu document.

[call [cmd hpdfDocObj] [method getCurrentEncoder]]
etCurrentEncoder gets the handle of the current encoder of the document object.
The current encoder is set by invoking [method setCurrentEncoder] and it is used to processing a text when an application invoks [method setInfoAttr] The default value of it is empty string.
See also "Fonts and Encodings" in original libharu document.
[call [cmd hpdfDocObj] [method setCurrentEncoder] [arg encodingname]]
setCurrentEncoder sets the current encoder for the document.
[para]
[arg [const encodingname]] is the name of an encoding.  See also "Fonts and Encodings" in original libharu document.

[call [cmd hpdfDocObj] [method useJPEncodings]]
useJPEncodings enables Japanese encodings. After useJPEncodings is involed, an application can use the following Japanese encodings.
[para]
[list_begin item]
    [item] 90ms-RKSJ-H
    [item] 90ms-RKSJ-V
    [item] 90msp-RKSJ-H
    [item] EUC-H
    [item] EUC-V
[list_end]

[call [cmd hpdfDocObj] [method useKREncodings]]
useKREncodings enables Korean encodings. After useKREncodings is involed, an application can use the following Korean encodings.
[para]
[list_begin item]
    [item] KSC-EUC-H
    [item] KSC-EUC-V
    [item] KSCms-UHC-H
    [item] KSCms-UHC-HW-H
    [item] KSCms-UHC-HW-V
[list_end]

[call [cmd hpdfDocObj] [method useCNSEncodings]]
useCNSEncodings enables simplified Chinese encodings. After useCNSEncodings is involed, an application can use the following simplified Chinese encodings.
[para]
[list_begin item]
    [item] GB-EUC-H
    [item] GB-EUC-V
    [item] GBK-EUC-H
    [item] GBK-EUC-V
[list_end]

[call [cmd hpdfDocObj] [method useCNTEncodings]]
useCNTEncodings enables traditional Chinese encodings. After useCNTEncodings is involed, an application can use the following traditional Chinese encodings.
[para]
[list_begin item]
    [item] GB-EUC-H
    [item] GB-EUC-V
    [item] GBK-EUC-H
    [item] GBK-EUC-V
[list_end]

[call [cmd hpdfDocObj] [method loadPngImageFromFile] [arg filename]]
loadPngImageFromFile loads an external png image file. 
It returns the handle of an image object.

[call [cmd hpdfDocObj] [method loadPngImageFromFile2] [arg filename]]
loadPngImageFromFile2 loads an external png image file.
It returns the handle of an image object.
[para]
Unlike loadPngImageFromFile, loadPngImageFromFile2 does not load whole data immediately. (only size and color properties is loaded).
[para]
The main data is loaded just before the image object is written to PDF, and the loaded data is deleted immediately. 

[call [cmd hpdfDocObj] [method loadJpegImageFromFile] [arg filename]]
loadJpegImageFromFile loads an external jpeg image file. 
It returns the handle of an image object.

[call [cmd hpdfDocObj] [method loadRawImageFromFile] [arg filename] [arg width] [arg heifht] [arg colorspace]]
loadRawImageFromFile loads an image which has "raw" image format. This method loads the data without any conversion. So it is usually faster than the other functions.
[para]
[arg filename] is a path to a image file.
[arg width] is the width of an image file.
[arg height] is the height of an image file.
[arg colorspace] allows [const gray], [const rgb] or [const cmyk].
[para]
loadRawImageFromFile can load 3 types of format described below.
[list_begin enumerated]
[enum][const {8 bit gray scale image.}]
The gray scale describes one pixel by one byte. And the size of the image data is same as width * height.
The sequence of the data is as follows.

[example {
 1  2  3  4
 6  7  8  9
11 12 13 14
}]
[enum][const {24bit RGB color image.}]
The 24bit RGB color image describes one pixel by 3 byte (each one byte describes a value of either red, green or blue). And the size of the image is same as width * height * 3.
The sequence of the data is as follows.
[example {
 1  1  1  2  2  2  3  3  3  4  4  4
 6  6  6  7  7  7  8  8  8  9  9  9
11 11 11 12 12 12 13 13 13 14 14 14
}]

[enum][const {36bit CMYK color image.}]
The 36bit CMYK color image describes one pixel by 4 byte (each one byte describes a value of either Cyan Magenta Yellow Black). And the size of the image is same as width * height * 4.
The sequence of the data is as follows.
[example {
 1  1  1  1  2  2  2  2  3  3  3  3  4  4  4  4
 6  6  6  6  7  7  7  7  8  8  8  8  9  9  9  9
11 11 11 11 12 12 12 12 13 13 13 13 14 14 14 14
}]

[list_end]

[call [cmd hpdfDocObj] [method loadRawImageFromMem] [arg buf] [arg width] [arg height] [arg colorspace] [arg bits_per_component]]
loadRawImageFromMem loads an image which has "raw" image format from buffer.
This method loads the data without any conversion. So it is usually faster than the other functions.
The formats that loadRawImageFromMem can load is the same as loadRawImageFromFile.
[para]
[arg buf] is the image data.
[arg width] is the width of an image file.
[arg height] is the height of an image file.
[arg colorspace] allows [const gray], [const rgb] or [const cmyk].
[arg bits_per_component] is the bit size of each color component. The valid value is either 1, 2, 4, 8.

[call [cmd hpdfDocObj] [method setInfoAttr] [arg type] [arg value]]
setInfoAttr sets the text of the info dictionary. setInfoAttr uses the current encoding of the document. If it is not set, the default value will be used.
[para]
[arg type] allows [const author], [const creator], [const title], [const subject] or [const keywords].
[arg value] is a text to set the infomation.

[call [cmd hpdfDocObj] [method getInfoAttr] [arg type]]
getInfoAttr gets the string value from info dictionary.
[para]
[arg type] allows [const creation_date], [const mod_date], [const author], [const creator], [const title], [const subject] or [const keywords].

[call [cmd hpdfDocObj] [method setInfoDateAttr] [arg type] [arg year] [arg month] [arg day] [arg hour] [arg min] [arg sec] [arg tzind] [arg tzhour] [arg tzmin]]
setInfoDateAttr sets the datetime value to the info dictionary. I tried to use tclclock values, but tcl8.4 could not handle timezone well, so I give up to map tcl clock value.
[para]
[arg type] allows [const creation_date] and [const mod_date]. 
[arg year] is year.
[arg month] must be between 1 and 12.
[arg day] must be between 1 and ether of 28, 29, 30, 31. (It is different by the month.)
[arg hour] must be between 0 to 23.
[arg min] must be between 0 to 59.
[arg sec] must be between 0 to 59.
[arg tzind] is the relationship of local time to Universal Time.  " ", +, ?, and Z are available.
[arg tzhour] is the timezone hour. If tzind is not space, 0 to 23 is valid. Otherwise, this value is ignored.
[arg tzmin] is the timezone min. If ind is not space, 0 to 59 is valid. Otherwise, this value is ignored.
[para]
[example {
# 2007-09-22 16:37:45 +09:00
$pdf setInfoDateAttr 2007 9 22 16 37 45 + 9 0
}]

[call [cmd hpdfDocObj] [method setPassword] [arg ownerpass] ?[arg userpass]?]
setPassword sets the pasword for the document.
If the password is set, contents in the document are encrypted. 
[para]
[arg owner_password] is the password for the owner of the document. The owner can change the permission of the document. Empty string and the same value as user password are not allowed.
[arg user_password] is the password for the user of the document. The user_password is allowed to be set to empty string.
[para]
If type of [arg owner_password] and [arg user_password] values are bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the values are assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfDocObj] [method setPermission] [arg permission]]
setPermission set the flags of the permission for the document.
[para]
The following values are available for [arg permission].
[list_begin definitions]
    [def read]
    user can read the document.
    [def print]
	user can print the document.
    [def edit_all]
    user can edit the contents of the document other than annotations, form fields.
    [def copy]
    user can copy the text and the graphics of the document.
    [def edit]
    user can add or modify the annotations and form fields of the document.
[list_end]

[call [cmd hpdfDocObj] [method setEncryptionMode] [arg mode] [arg keylen]]
setEncryptionMode set the type of encryption.
As the side effect, setEncryptionMode ups the version of PDF to 1.4 when the mode is set to r3.
[para]
[arg mode] specify which operations are permitted. This parameter is set by logical addition of the following values.
[list_begin enumerated]
[enum] r2 :
Use "Revision 2" algorithm.
The length of key is automatically set to 5(40bit).
[enum] r3 :
Use "Revision 3" algorithm.
Between 5(40bit) and 16(128bit) can be specified for length of the key. 
[list_end]
[para]
[arg keylen] specify the byte length of an encryption key. This parameter is valid only when "mode" parameter is set to r3.  Between 5(40bit) and 16(128bit) can be specified for length of the key.


[call [cmd hpdfDocObj] [method setCompressionMode] [arg mode]]
setCompressionMode set the mode of compression.
[para]
The following values are available for [arg mode].
[list_begin definitions]
    [def none]
    All contents are not compressed.
    [def text]
	Compress the contents stream of the page.  
    [def image]
	Compress the streams of the image objects.  
    [def metadata]
    Other stream datas (fonts, cmaps and so on) are compressed.
    [def all]
    All stream datas are compressed.
[list_end]

[call [cmd hpdfDocObj] [method createExtGState]]
createExtGState create hpdfExtGStateObj and return it.

[list_end]


[section REFERENCE]
[list_begin bullet]
	[bullet]
	[uri http://libharu.sourceforge.net/]
[list_end]


[keywords pdf]
[see_also tclhpdf tclhpdfDoc tclhpdfPage tclhpdfImage tclhpdfFont tclhpdfOutline tclhpdfEncoder tclhpdfDescription tclhpdfAnnotation tclhpdfExtGState]
[manpage_end]
