[manpage_begin tclhpdf 3 0.1.0]
[copyright {1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>}]
[copyright {2007 OHTSUKA, yoshio <ohtsuka.yoshio@gmail.com>}]
[moddesc   {tclhpdf Font Handler}]
[description]
The Font handler command have subcommands for font handling.

[usage COMMANDS]
[section COMMANDS]
[list_begin definitions]
[call [cmd hpdfFontObj] [method getFontName]]
getFontName gets the name of the font.

[call [cmd hpdfFontObj] [method getEncodingName]]
getEncodingName gets the encoding name of the font.

[call [cmd hpdfFontObj] [method getUnicodeWidth] [arg unichar]]
getUnicodeWidth gets the width of a charactor in the font.
Actual width of the character on the page can be calculated by the following expressions. 
[example {
set char_width [$font getUnicodeWidth $UNICODE]
set actual_width [expr {$char_width * $FONT_SIZE / 1000.0}]
}]

[call [cmd hpdfFontObj] [method getBBox]]
getBBox gets the bounding box of the font.
It returns a list {left bottom right top}.

[call [cmd hpdfFontObj] [method getAscent]]
getAscent gets the vertical ascent of the font. 

[call [cmd hpdfFontObj] [method getDescent]]
getDescent gets the vertical descent of the font. 

[call [cmd hpdfFontObj] [method getXHeight]]
getXHeight gets the distance from the baseline of lowercase letters.

[call [cmd hpdfFontObj] [method getCapHeight]]
getCapHeight gets the distance from the baseline of uppercase letters. 

[call [cmd hpdfFontObj] [method textWidth] [arg text] [arg len]]
textWidth gets total width of the text, number of charactors and number of the words. 
[para]
[arg text] is the text to get width.
[arg len] is the char length if the text is string. if the text is bytearray it is the byte length.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfFontObj] [method measureText] [arg text] [arg len] [arg width] [arg fontsize] [arg charspace] [arg wordspace] [arg wordwrap] ?[arg realwidthName]? ]
measureText calculates the byte length which can be included within the specified width.
[para]
[arg text] is the text to get width.
[arg len] is the char length if the text is string. if the text is bytearray it is the byte length.
[arg width] is the width of the area to put the text.
[arg fontsize] is the size of the font.
[arg charspace] is the character spacing.
[arg wordspace] is the word spacing.
[arg wordwrap].
When there are three words of "ABCDE", "FGH", and "IJKL", and the substring until "J" can be included within the width, if word_wrap parameter is HPDF_FALSE it returns 12,  and if word_wrap parameter is HPDF_FALSE word_wrap parameter is HPDF_FALSE it returns 10 (the end of the previous word).
[example {
 1  2  3  4  5  6  7  8  9 10 11 12 13 14
 A  B  C  D  E     F  G  H     I  J  K  L
 <-------------------------------->
}]
[arg realwidthName] is the variable name. If this parameter is set, the real widths of the text is set.

[list_end]


[section REFERENCE]
[list_begin bullet]
	[bullet]
	[uri http://libharu.sourceforge.net/]
[list_end]


[keywords pdf]
[see_also tclhpdf tclhpdfDoc tclhpdfPage tclhpdfImage tclhpdfFont tclhpdfOutline tclhpdfEncoder tclhpdfDescription tclhpdfAnnotation tclhpdfExtGState]
[manpage_end]
