[manpage_begin tclhpdf 2 0.1.0]
[copyright {1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>}]
[copyright {2007 OHTSUKA, yoshio <ohtsuka.yoshio@gmail.com>}]
[moddesc   {tclhpdf Image Handler}]
[description]
The Image handler command have subcommands to control images.

[usage COMMANDS]
[section COMMANDS]
[list_begin definitions]
[call [cmd hpdfImageObj] [method getSize]]
getSize gets the size of the image of an image object.
It returns tcl list {width height}.

[call [cmd hpdfImageObj] [method getSize2] [arg sizeName]]
getSize2 gets the size of the image of an image object.
It doen't return value, but set the result to [arg sizeName] varible. The return value is same as getSize.

[call [cmd hpdfImageObj] [method getWidth]]
getWidth gets the width of the image of an image object.

[call [cmd hpdfImageObj] [method getHeight]]
getHeight gets the height of the image of an image object.

[call [cmd hpdfImageObj] [method getBitsPerComponent]]
getBitsPerComponent gets the number of bits used to describe each color component.

[call [cmd hpdfImageObj] [method getColorSpace]]
getColorSpace gets the name of the image's color space.
It returns a string "DeviceGray", "DeviceRGB", "DeviceCMYK" or "Indexed".

[call [cmd hpdfImageObj] [method setColorMask] [arg rmin] [arg rmax] [arg gmin] [arg gmax] [arg bmin] [arg bmax]]
setColorMask sets the transparent color of the image by the RGB range values.
The color within the range is displayed as a transparent color.
The Image must be RGB color space.
[para]
[arg rmin] is the lower limit of Red. It must be between 0 and 255.
[arg rmax] is the upper limit of Red. It must be between 0 and 255.
[arg gmin] is the lower limit of Green. It must be between 0 and 255.
[arg gmax] is the upper limit of Green. It must be between 0 and 255.
[arg bmin] is the lower limit of Blue. It must be between 0 and 255.
[arg bmax] is the upper limit of Blue. It must be between 0 and 255.

[call [cmd hpdfImageObj] [method setMaskImage] [arg hpdfImageObj]]
setMaskImage sets the mask image. 
[para]
the arg image specify the handle of an image object which is used as image-mask. This image must be 1bit gray-scale color image. 
[list_end]


[section REFERENCE]
[list_begin bullet]
	[bullet]
	[uri http://libharu.sourceforge.net/]
[list_end]


[keywords pdf]
[see_also tclhpdf tclhpdfDoc tclhpdfPage tclhpdfImage tclhpdfFont tclhpdfOutline tclhpdfEncoder tclhpdfDescription tclhpdfAnnotation tclhpdfExtGState]
[manpage_end]
