[manpage_begin tclhpdfPage 2 0.1.0]
[copyright {1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>}]
[copyright {2007 OHTSUKA, yoshio <ohtsuka.yoshio@gmail.com>}]
[moddesc   {tclhpdf Page Handler}]
[description]
The Page handler command have subcommands to control page preferences and draw elements.

[usage COMMANDS]
[section COMMANDS]
[list_begin definitions]
[call [cmd hpdfPageObj] [method setWidth] [arg width]]
setWidth changes the width of a page.
The valid value is between 3 and 14400.
[call [cmd hpdfPageObj] [method setHeight] [arg height]]
setHeight changes the height of a page.
The valid value is between 3 and 14400.
[call [cmd hpdfPageObj] [method setSize] [arg size] [arg direction]]
setSize changes the size and direction of a page to a predefined size.
[para]
[arg size] specify a predefined page-size value. The following values are available.
[list_begin definitions]
	[def [const letter]] 8.5 x 11 (inches) 	612 x 792
	[def [const legal]] 8.5 x 14 (inches) 	612 x 1008
	[def [const a3]] 297 $B!_(B 420 (mm) 841.89 x 1199.551
	[def [const a4]] 210 $B!_(B 297 (mm) 595.276 x 841.89
	[def [const a5]] 148 $B!_(B 210 (mm) 	419.528 x 595.276
	[def [const b4]] 250 $B!_(B 353 (mm) 	708.661 x 1000.63
	[def [const b5]] 176 $B!_(B 250 (mm) 	498.898 x 708.661
	[def [const executive]] 7.5 x 10.5 (inches) 522 x 756
	[def [const us4x6]] 4 x 6 (inches) 288 x 432
	[def [const us4x8]] 4 x 8 (inches)
	[def [const us5x7]] 5 x 7 (inches) 360 x 504
	[def [const comm10]] 4.125 x 9.5 (inches) 	297x 684
[list_end]
[para]
[arg direction] specify the direction of the page.
[list_begin definitions]
	[def [const portrait]] 
    Set the longer value to horizontal.
	[def [const landscape]] 
    Set the longer value to vertical.
[list_end]

[call [cmd hpdfPageObj] [method setRotate] [arg angle]]
setRotate sets rotation angle of the page.
[para]
[arg angle] specify the rotation angle of the page.
It must be a multiple of 90 Degrees.

[call [cmd hpdfPageObj] [method createDestination]]
createDestination creates a new destination object for the page. and returns a handle of the new destination object.

[call [cmd hpdfPageObj] [method createTextAnnot] [arg rect] [arg text] ?[arg encoder]?]
createTextAnnot creates a new text annotation object for the page. And it returns a handle of the new annotation object.
[para]
[arg rect] is a rectangle where the annotation is displayed. It is a tcl list {left bottom right top}.
[arg text] is the text to be displayed.
[arg encoder] is an encoder handle which is used to encode the text. If it is empty string or omitted default value will be used.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method createLinkAnnot] [arg rect] [arg hpdfDestinationObj]]
createLinkAnnot creates a new link annotation object for the page. it returns a handle of the new annotation object.
[para]
[arg rect] is a rectangle of clickable area. It is a tcl list {left bottom right top}.
[arg dst] is a handle of destination object to jump to.

[call [cmd hpdfPageObj] [method createURILinkAnnot] [arg rect] [arg uri]]
createURILinkAnnot creates a new web link annotation object for the page. It returns a handle of the new annotation object.
[para]
[arg rect] is a rectangle of clickable area.
It is a tcl list {left bottom right top}.
[arg uri] is URL of destination to jump to.

[call [cmd hpdfPageObj] [method textWidth] [arg text]]
textWidth gets the width of the text in current fontsize, character spacing and word spacing. It returns the width of the text in current fontsize, character spacing and word spacing.
[para]
[arg text] is the text to get width. If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method measureText] [arg text] [arg width] [arg wordwrap] ?[arg realwidthName]?]
measureText calculates the length which can be included within the specified width. It returns the length which can be included within the specified width in current fontsize, character spacing and word spacing.
[para]
[arg text] is the text to get width.
[arg width] is the width of the area to put the text.
[arg wordwrap].  When there are three words of "ABCDE", "FGH", and "IJKL", and the substring until "J" can be included within the width, if wordwrap parameter is false it returns 12,  and if wordwrap parameter is false wordwrap parameter is false it returns 10 (the end of the previous word).
[example {
 1  2  3  4  5  6  7  8  9 10 11 12 13 14
 A  B  C  D  E     F  G  H     I  J  K  L
 <-------------------------------->
}]
[arg realwidthName] is a variable name.  If this parameter is specified , the real widths of the text is set to the variable.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method getWidth]]
getWidth gets the height of a page.
[call [cmd hpdfPageObj] [method getHeight]]
getHeight gets the height of a page. 
[call [cmd hpdfPageObj] [method getGMode]]
getGMode gets the current graphics mode.

[call [cmd hpdfPageObj] [method getCurrentPos]]
getCurrentPos gets the current position for path painting.
An application can invoke getCurrentPos only when graphics mode is [const path_object]. It returns a point list {x y}.

[call [cmd hpdfPageObj] [method getCurrentPos2] [arg posName]]
This is same as getCurrentPos, but the points is set to [arg posName]

[call [cmd hpdfPageObj] [method getCurrentTextPos]]
getCurrentTextPos gets the current position for text showing.
An application can invoke getCurrentTextPos only when graphics mode is [const text_object]. It returns a point list {x y}.

[call [cmd hpdfPageObj] [method getCurrentTextPos2] [arg posName]]
This is same as getCurrentTextPos, but the points is set to [arg posName].

[call [cmd hpdfPageObj] [method getCurrentFont]]
getCurrentFont gets the handle of the page's current font.

[call [cmd hpdfPageObj] [method getCurrentFontSize]]
getCurrentFontSize gets the size of the page's current font.

[call [cmd hpdfPageObj] [method getTransMatrix]]
getTransMatrix gets the current transformation matrix of the page. the returned matrix is a list {a b c d x y}.

[call [cmd hpdfPageObj] [method getLineWidth]]
getLineWidth gets the current line width of the page.
It returns the current line width for path painting of the page.

[call [cmd hpdfPageObj] [method getLineCap]]
getLineCap gets the current line cap style of the page.
It returns the current line cap style of the page.

[call [cmd hpdfPageObj] [method getLineJoin]]
getLineJoin gets the current line join style of the page.
It returns the current line join style of the page.

[call [cmd hpdfPageObj] [method getMiterLimit]]
getMiterLimit gets the current value of the page's miter limit.
It returns the current value of the page's miter limit.

[call [cmd hpdfPageObj] [method getDash]]
getDash gets the current pattern of the page.
It returns a list of the current pattern of the page.
the list is a {pattern phase}. ex {{3 5 3} 2}.

[call [cmd hpdfPageObj] [method getFlat]]
getMiterLimit gets the current value of the page's flatness.

[call [cmd hpdfPageObj] [method getCharSpace]]
getCharSpace gets the current value of the page's character spacing.

[call [cmd hpdfPageObj] [method getWordSpace]]
getWordSpace returns the current value of the page's word spacing.

[call [cmd hpdfPageObj] [method getHorizontalScalling]]
getHorizontalScalling returns the current value of the page's horizontal scalling for text showing.

[call [cmd hpdfPageObj] [method getTextLeading]]
getTextLeading returns the current value of the page's line spacing.

[call [cmd hpdfPageObj] [method getTextRenderingMode]]
getTextRenderingMode returns the current value of the page's text rendering mode.

[call [cmd hpdfPageObj] [method getTextRise]]
getTextRise returns the current value of the page's text rising.

[call [cmd hpdfPageObj] [method getRGBFill]]
getRGBFill returns the current value of the page's filling color. getRGBFill is valid only when the page's filling color space is rgb. 
The returned value is a list {r g b}.

[call [cmd hpdfPageObj] [method getRGBStroke]]
getRGBStroke returns the current value of the page's stroking color. getRGBStroke is valid only when the page's stroking color space is rgb.
The returned value is a list {r g b}.

[call [cmd hpdfPageObj] [method getCMYKFill]]
getCMYKFill returns the current value of the page's filling color. getCMYKFill is valid only when the page's filling color space is cmyk.
The returned value is a list {c m y k}.

[call [cmd hpdfPageObj] [method getCMYKStroke]]
getCMYKStroke returns the current value of the page's stroking color. getCMYKStroke is valid only when the page's stroking color space is cmyk.
The returned value is a list {c m y k}.

[call [cmd hpdfPageObj] [method getGrayFill]]
getGrayFill returns the current value of the page's filling color. getGrayFill is valid only when the page's stroking color space is gray.

[call [cmd hpdfPageObj] [method getGrayStroke]]
getGrayStroke returns the current value of the page's stroking color. getGrayStroke is valid only when the page's stroking color space is gray.

[call [cmd hpdfPageObj] [method getStrokingColorSpace]]
getStrokingColorSpace returns the current value of the page's stroking color space.

[call [cmd hpdfPageObj] [method getFillingColorSpace]]
getFillingColorSpace returns the current value of the page's stroking color space.

[call [cmd hpdfPageObj] [method getTextMatrix]]
getTextMatrix gets the current text transformation matrix of the page. The returned matrix is a list {a b c d x y}.

[call [cmd hpdfPageObj] [method getGStateDepth]]
getGStateDepth returns the number of the page's graphics state stack.

[call [cmd hpdfPageObj] [method setLineWidth] [arg width]]
setLineWidth sets the width of the line used to stroke a path. An application can invoke setLineWidth when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setLineCap] [arg linecap]]
setLineCap sets the shape to be used at the ends of line.
An application can invoke setLineCap when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg linecap] is the style of line-cap.
[list_begin definitions]
[def [const butt_end]]
The line is squared off at the endpoint of the path.
[def [const round_end]]
The end of a line becomes a semicircle whose center is the end point of the path.
[def [const projecting_scuare_end]]
The line continues to the point that exceeds half of the stroke width the end point. 
[list_end]
[para]

[call [cmd hpdfPageObj] [method setLineJoin] [arg linejoin]]
setLineJoin sets the line join style in the page.
An application can invoke setLineJoin when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg linejoin] is the style of line-jpin.
[list_begin definitions]
[def [const miter_join]]
[def [const round_join]]
[def [const bevel_join]]
[list_end]
[para]

[call [cmd hpdfPageObj] [method setMiterLimit] [arg milterlimit]]
setMiterLimit sets the miter limit in the page.

[call [cmd hpdfPageObj] [method setDash] [arg dashlist] [arg phase]]
setDash sets the line dash pattern in the page.
An application can invoke setDash when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg dashlist] is a list of dashes and gaps length.
[arg phase] is the phase in which the pattern begins.

[call [cmd hpdfPageObj] [method setFlat] [arg flatness]]
setFlat sets the flatness in the page.

[call [cmd hpdfPageObj] [method setExtGState] [arg hpdfExtGStateObj]]
setExtGState applys the graphics state to the page.
An application can invoke gSave when the graphics mode of the page is in [const page_description].

[call [cmd hpdfPageObj] [method gSave]]
gSave saves the page's current graphics parameter to the stack. An application can invoke gSave up to 28 and can restore the saved parameter by invoking gRestore.
[para]
The parameters that are saved by gSave is as follows.
[example {
Transformation Matrix
Line Width
Line Cap Style
Line Join Style
Miter Limit
Dash Mode
Flatness
Character Spacing
Word Spacing
Horizontal Scalling
Text Leading
Rendering Mode
Text Rise
Filling Color
Stroking Color
Font
Font Size
}]
An application can invoke gSave when the graphics mode of the page is in [const page_description].

[call [cmd hpdfPageObj] [method gRestore]]
gRestore restore the graphics state which is saved by gSave.
An application can invoke gSave when the graphics mode of the page is in [const page_description].

[call [cmd hpdfPageObj] [method concat] [arg a] [arg b] [arg c] [arg d] [arg x] [arg y]]
concat concatenates the page's current transformation matrix and specified matrix.
For example, if you want to rotate the coordinate system of the page by 45 degrees, use concat as follows.
[example {
set rad1 [expr {45 / 180.0 * 3.141592}]
$page concat \
    [expr {cos($rad1)}] \
    [expr {sin($rad1)}] \
    [expr {-sin($rad1)}] \
    [expr {cos($rad1)}] \
    220 350
}]
Additionally to change the coordinate system of the page to 300dpi, use concat as follows.
[example {
$page concat \
    [expr {72.0 / 300.0}] \
    0 \
    0 \
    [expr {72.0 / 300.0}] \
    0 0
}]
Invoke gSave before concat. Then the change by concat can be restored by invoking gRestore.
[example {
# save the current graphics states
$page gSave

# concatenate the transformation matrix
$page concat \
    [expr {72.0 / 300.0}] \
    0 \
    0 \
    [expr {72.0 / 300.0}] \
    0 0

# show text on the translated coordinates 
$page beginText
$page moveTextPos 50 100
$page showText "Text on the translated coordinates"
$page endText

# restore the graphics states
$page gRestore
}]
An application can invoke gSave when the graphics mode of the page is in [const page_description].
[para]
[arg a] [arg b] [arg c] [arg d] [arg x] [arg y] are the transformation matrix to concatenate.

[call [cmd hpdfPageObj] [method moveTo] [arg x] [arg y]]
moveTo starts a new subpath and move the current point for drawing path,  moveTo sets the start point for the path to the point (x, y) and changes the graphics mode to [const path_object].
An application can invoke moveTo when the graphics mode of the page is in [const page_description] or [const path_object].

[call [cmd hpdfPageObj] [method lineTo] [arg x] [arg y]]
lineTo appends a path from the current point to the specified point.
An application can invoke lineTo when the graphics mode of the page is in [const path_object].

[call [cmd hpdfPageObj] [method curveTo] [arg x1] [arg y1] [arg x2] [arg y2] [arg x3] [arg y3]]
curveTo appends a Bezier curve to the current path using two spesified points.
The point (x1, y1) and the point (x2, y2) are used as the control points for a Bezier curve and current point is moved to the point (x3, y3).
An application can invoke curveTo when the graphics mode of the page is in [const path_object].

[call [cmd hpdfPageObj] [method curveTo2] [arg x2] [arg y2] [arg x3] [arg y3]]
curveTo2 appends a Bezier curve to the current path using two spesified points.
The current point and the point (x2, y2) are used as the control points for a Bezier curve and current point is moved to the point (x3, y3).
An application can invoke curveTo3 when the graphics mode of the page is in [const path_object].

[call [cmd hpdfPageObj] [method curveTo3] [arg x1] [arg y1] [arg x3] [arg y3]]
curveTo3 appends a Bezier curve to the current path using two spesified points.
The point (x1, y1) and the point (x3, y3) are used as the control points for a Bezier curve and current point is moved to the point (x3, y3).
An application can invoke curveTo2 when the graphics mode of the page is in [const path_object].

[call [cmd hpdfPageObj] [method closePath]]
closePath appends a strait line from the current point to the start point of sub path.
The current point is moved to the start point of sub path.
An application can invoke curveTo2 when the graphics mode of the page is in [const path_object].

[call [cmd hpdfPageObj] [method rectangle] [arg x] [arg y] [arg width] [arg height]]
rectangle appends a rectangle to the current path.
An application can invoke rectangle when the graphics mode of the page is in [const page_description] or [const path_object].
[para]
[arg x] [arg y] are the lower-left point of the rectangle.
[arg width] is width of the rectangle.
[arg height] is height of the rectangle.

[call [cmd hpdfPageObj] [method stroke]]
stroke paints the current path.
An application can invoke stroke when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method closePathStroke]]
closePathStroke closes the current path, then it paints the path.
An application can invoke closePathStroke when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method fill]]
fill fills the current path using the nonzero winding number rule.
An application can invoke fill when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method eofill]]
eofill fills the current path using the even-odd rule.
An application can invoke eofill when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method fillStroke]]
fillStroke fills the current path using the nonzero winding number rule, then it paints the path.
An application can invoke fillStroke when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method eofillStroke]]
eofillStroke fills the current path using the even-odd rule, then it paints the path.
An application can invoke eofillStroke when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method closePathFillStroke]]
closePathFillStroke closes the current path, fills the current path using the nonzero winding number rule, then it paints the path.
An application can invoke closePathFillStroke when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method closePathEofillStroke]]
closePathEofillStroke closes the current path, fills the current path using the even-odd rule, then it paints the path.
An application can invoke closePathEofillStroke when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method endPath]]
endPath ends the path object without filling and painting operation.
An application can invoke endPath when the graphics mode of the page is in [const path_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method clip]]
TODO
[call [cmd hpdfPageObj] [method eoclip]]
TODO
[call [cmd hpdfPageObj] [method beginText]]
beginText begins a text object and sets the current text position to the point (0, 0).
An application can invoke beginText when the graphics mode of the page is in [const page_description]. And it changes the graphics mode to [const text_object].

[call [cmd hpdfPageObj] [method endText]]
endText ends a text object.
An application can invoke endText when the graphics mode of the page is in [const text_object]. And it changes the graphics mode to [const page_description].

[call [cmd hpdfPageObj] [method setCharSpace] [arg value]]
setCharSpace sets the character spacing for text showing.
The initial value of character spacing is 0.
An application can invoke setCharSpace when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setWordSpace] [arg value]]
setWordSpace sets the word spacing for text showing.
The initial value of word spacing is 0.
An application can invoke setWordSpace when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setHorizontalScalling] [arg value]]
setHorizontalScalling sets the horizontal scalling for text showing.
The initial value of horizontal scalling is 100.
An application can invoke setHorizontalScalling when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setTextLeading] [arg value]]
setTextLeading sets the text leading (line spacing) for text showing.
The initial value of leading is 0.
An application can invoke setTextLeading when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setFontAndSize] [arg hpdfFontObj] [arg size]]
setFontAndSize sets the type of font and size leading.
An application can invoke setFontAndSize when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setTextRenderingMode] [arg mode]]
setTextRenderingMode sets the text rendering mode.
The initial value of text rendering mode is [const fill].
An application can invoke setTextRenderingMode when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg mode] is the text rendering mode (one of the following values).
[list_begin definitions]
[def [const fill]]
[def [const stroke]]
[def [const fill_then_stroke]]
[def [const invisible]]
[def [const fill_clipping]]
[def [const stroke_clipping]]
[def [const fill_stroke_clipping]]
[def [const clipping]]
[list_end]

[call [cmd hpdfPageObj] [method setTextRise] [arg value]]
TODO

[call [cmd hpdfPageObj] [method moveTextPos] [arg x] [arg y]]
moveTextPos moves the current text position to the start of the next line with using specified offset values. If the start position of the current line is (x1, y1), the start of the next line is (x1 + x, y1 + y).
An application can invoke moveTextPos when the graphics mode of the page is in [const text_object].
[para]
[arg x] [arg y] are offset of the start of the next line.

[call [cmd hpdfPageObj] [method moveTextPos2] [arg x] [arg y]]
moveTextPos2 moves the current text position to the start of the next line with using specified offset values, and sets the text-leading to -y. If the start position of the current line is (x1, y1), the start of the next line is (x1 + x, y1 + y).
An application can invoke moveTextPos2 when the graphics mode of the page is in [const text_object].
[para]
[arg x] [arg y] are offset of the start of the next line.

[call [cmd hpdfPageObj] [method setTextMatrix] [arg a] [arg b] [arg c] [arg d] [arg x] [arg y]]
TODO

[call [cmd hpdfPageObj] [method moveToNextLine]]
moveTextPos2 moves the current text position to the start of the next line. If the start position of the current line is (x1, y1), the start of the next line is (x1, y1 - text leading).
An application can invoke moveTextPos2 when the graphics mode of the page is in [const text_object].
[para]
NOTE:
Since the default value of Text Leading is 0,  an application have to invoke setTextLeading before moveTextPos2 to set text leading. 

[call [cmd hpdfPageObj] [method showText] [arg text]]
showText prints the text at the current position on the page.
An application can invoke showText when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg text] is the text to print.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method showTextNextLine] [arg text]]
showTextNextLine moves the current text position to the start of the next line, then prints the text at the current position on the page.
An application can invoke showTextNextLine when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg text] is the text to print.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method showTextNextLineEx] [arg wordspace] [arg charspace] [arg text]]
showTextNextLineEx moves the current text position to the start of the next line, then sets the word spacing, character spacing and prints the text at the current position on the page.
An application can invoke showTextNextLine when the graphics mode of the page is in [const page_description] or [const text_object].
[para]
[arg wordspace] is the word spacing.
[arg charspace] is the character spacing.
[arg text] is the text to print.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method setGrayFill] [arg gray]]
setGrayFill sets the filling color.
An application can invoke setGrayFill when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setGrayStroke] [arg gray]]
setGrayStroke sets the stroking color.
An application can invoke setGrayStroke when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setRGBFill] [arg r] [arg g] [arg b]]
setRGBFill sets the filling color.
An application can invoke setRGBFill when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setRGBStroke] [arg r] [arg g] [arg b]]
setRGBStroke sets the stroking color.
An application can invoke setRGBStroke when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setCMYKFill] [arg c] [arg m] [arg y] [arg k]]
setCMYKFill sets the filling color.
An application can invoke setCMYKFill when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method setCMYKStroke] [arg c] [arg m] [arg y] [arg k]]
setCMYKStroke sets the stroking color.
An application can invoke setCMYKStroke when the graphics mode of the page is in [const page_description] or [const text_object].

[call [cmd hpdfPageObj] [method executeXObject] [arg xobject]]
TODO

[call [cmd hpdfPageObj] [method drawImage] [arg image] [arg x] [arg y] [arg width] [arg height]]
drawImage shows an image in one operation.
An application can invoke drawImage when the graphics mode of the page is in [const page_description].
[para]
[arg x] [arg y] are the lower-left point of the region where image is displayed.
[arg width] is the width of the region where image is displayed.
[arg height] is the height of the region where image is displayed.

[call [cmd hpdfPageObj] [method circle] [arg x] [arg y] [arg ray]]
circle appends a circle to the current path.
An application can invoke circle when the graphics mode of the page is in [const page_description] or [const path_object].
[para]
[arg x] [arg y] are the lower-left point of the region where image is displayed.
[arg ray] is the ray of the circle.

[call [cmd hpdfPageObj] [method ellipse] [arg x] [arg y] [arg xray] [arg yray]]
ellipse appends a ellipse to the current path.
An application can invoke ellipse when the graphics mode of the page is in [const page_description] or [const path_object].
[para]
[arg x] [arg y] are the lower-left point of the region where image is displayed.
[arg xray] [arg yray] are the ray of the circle.

[call [cmd hpdfPageObj] [method arc] [arg x] [arg y] [arg ray] [arg ang1] [arg ang2]]
arc appends a circle to the current path.
An application can invoke arc when the graphics mode of the page is in [const page_description] or [const path_object].
[para]
[arg x] [arg y] are the center point of the circle.
[arg ray] is the ray of the circle.
[arg ang1] is the angle of the begining of the arc.
[arg ang2] is the angle of the end of the arc. It must be greater than ang1.

[call [cmd hpdfPageObj] [method textOut] [arg xpos] [arg ypos] [arg text]]
textOut prints the text on the specified position.
An application can invoke textOut when the graphics mode of the page is in [const text_object].
[para]
[arg xpos] [arg ypos] are the point position where the text is displayed.
[arg text] is the text to show.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method textRect] [arg left] [arg top] [arg right] [arg bottom] [arg text] [arg align] ?[arg len]?]
textRect print the text inside the specified region. The characters which is not ((The original manual lacks following description.))
An application can invoke textRect when the graphics mode of the page is in [const text_object].
The handle of a page object.
[para]
[arg left] [arg top] [arg right] [arg bottom]
Coordinates of corners of the region to output text.
[arg text] is the text to show.
[arg align] is the alignment of the text.
[list_begin definitions]
[def [const left]] The text is aligned to left.
[def [const right]] The text is aligned to right.
[def [const center]] The text is aligned to center.
[def [const justify]] Add spaces between the words to justify both left and right side.
[list_end]
[arg len] is a variable name. The number of characters which was printed in the area is set to the variable.
[para]
If type of [arg text] values is bytearray, this function use the value as it is (bytearray). But if the type is not bytearray (string or any), the value is assumed as tcl native string(utf-8) and convert to external encoding(encoding system), then pass to hpdf functions. This may be a little confusion, but it is convenient to set another encoding strings.

[call [cmd hpdfPageObj] [method setSlideShow] [arg type] [arg disptime] [arg transtime]]
setSlideShow configures the setting for slide transition of the page.
[para]
[arg type] is the transition style. The following values are available.
[list_begin definitions]
[def [const wipe_right]]
[def [const wipe_up]]
[def [const wipe_left]]
[def [const wipe_down]]
[def [const barn_doors_horizontal_out]]
[def [const barn_doors_horizontal_in]]
[def [const barn_doors_vertical_out]]
[def [const barn_doors_vertical_in]]
[def [const box_out]]
[def [const box_in]]
[def [const blinds_horizontal]]
[def [const blinds_vertical]]
[def [const dissolve]]
[def [const glitter_right]]
[def [const glitter_down]]
[def [const glitter_top_left_to_bottom_right]]
[def [const replace]]
[list_end]

[arg disptime] is the display duration of the page. (in seconds)
[arg transtime] is the duration of the transition effect. Default value is 1(second).


[list_end]


[section REFERENCE]
[list_begin bullet]
	[bullet]
	[uri http://libharu.sourceforge.net/]
[list_end]


[keywords pdf]
[see_also tclhpdf tclhpdfDoc tclhpdfPage tclhpdfImage tclhpdfFont tclhpdfOutline tclhpdfEncoder tclhpdfDescription tclhpdfAnnotation tclhpdfExtGState]
[manpage_end]
