#include "tclhpdf.h"


/* ==============================================================
 * 
 * hpdf_consts.h
 *
 * ==============================================================*/
const char *optionCompressionModeString[] = {
    "none",
    "text",
    "image",
    "metadata",
    "all",
/*    "best_compress",*/
/*    "best_speed",*/
    (char*)NULL
};
const int optionCompressionModeEnum[] = {
    HPDF_COMP_NONE,
    HPDF_COMP_TEXT,
    HPDF_COMP_IMAGE,
    HPDF_COMP_METADATA,
    HPDF_COMP_ALL,
/*    HPDF_COMP_BEST_COMPRESS,*/
/*    HPDF_COMP_BEST_SPEED*/
};


const char *optionPermissionString[] = {
    "read",
    "print",
    "edit_all",
    "copy",
    "edit",
    (char*)NULL
};
const int optionPermissionEnum[] = {
    HPDF_ENABLE_READ,
    HPDF_ENABLE_PRINT,
    HPDF_ENABLE_EDIT_ALL,
    HPDF_ENABLE_COPY,
    HPDF_ENABLE_EDIT
};


const char *optionViewerPreferenceString[] = {
    "hide_toolbar",
    "hide_menubar",
    "hide_window_ui",
    "fit_window",
    "center_window",
    (char*)NULL
};
const int optionViewerPreferenceEnum[] = {
    HPDF_HIDE_TOOLBAR,
    HPDF_HIDE_MENUBAR,
    HPDF_HIDE_WINDOW_UI,
    HPDF_FIT_WINDOW,
    HPDF_CENTER_WINDOW
};


/*const char *optionCountryCodeString[] = {*/
/*};*/
/*const char *optionLanguageCodeString[] = {*/
/*};*/


const char *optionGraphicsModeString[] = {
    "page_description",
    "path_object",
    "text_object",
    "clipping_path",
    "shading",
    "inline_image",
    "external_object",
    (char*)NULL
};
const int optionGraphicsModeEnum[] = {
    HPDF_GMODE_PAGE_DESCRIPTION,
    HPDF_GMODE_PATH_OBJECT,
    HPDF_GMODE_TEXT_OBJECT,
    HPDF_GMODE_CLIPPING_PATH,
    HPDF_GMODE_SHADING,
    HPDF_GMODE_INLINE_IMAGE,
    HPDF_GMODE_EXTERNAL_OBJECT
};

/* ==============================================================
 * 
 * hpdf_types.h (enums)
 *
 * ==============================================================*/
const char *optionInfoTypeGetString[] = {
    "creation_date",
    "mod_date",
    "author",
    "creator",
    "producer",
    "title",
    "subject",
    "keywords",
    (char*)NULL
};
const HPDF_InfoType optionInfoTypeGetEnum[] = {
    HPDF_INFO_CREATION_DATE,
    HPDF_INFO_MOD_DATE,
    HPDF_INFO_AUTHOR,
    HPDF_INFO_CREATOR,
    HPDF_INFO_PRODUCER,
    HPDF_INFO_TITLE,
    HPDF_INFO_SUBJECT,
    HPDF_INFO_KEYWORDS
};
const char *optionInfoTypeSetString[] = {
    "author",
    "creator",
    "producer",
    "title",
    "subject",
    "keywords",
    (char*)NULL
};
const HPDF_InfoType optionInfoTypeSetEnum[] = {
    HPDF_INFO_AUTHOR,
    HPDF_INFO_CREATOR,
    HPDF_INFO_PRODUCER,
    HPDF_INFO_TITLE,
    HPDF_INFO_SUBJECT,
    HPDF_INFO_KEYWORDS
};
const char *optionInfoTypeDateString[] = {
    "creation_date",
    "mod_date",
    (char*)NULL
};
const HPDF_InfoType optionInfoTypeDateEnum[] = {
    HPDF_INFO_CREATION_DATE,
    HPDF_INFO_MOD_DATE
};


const char *optionPDFVerString[] = {
    "12",
    "13",
    "14",
    "15",
    "16",
    (char*)NULL
};
const HPDF_PDFVer optionPDFVerEnum[] = {
    HPDF_VER_12,
    HPDF_VER_13,
    HPDF_VER_14,
    HPDF_VER_15,
    HPDF_VER_16
};


const char *optionEncryptModeString[] = {
    "r2",
    "r3",
    (char*)NULL
};
const HPDF_EncryptMode optionEncryptModeEnum[] = {
    HPDF_ENCRYPT_R2,
    HPDF_ENCRYPT_R3
};


const char *optionColorSpaceString[] = {
    "device_gray",
    "device_rgb",
    "device_cmyk",
    "cal_gray",
    "cal_rgb",
    "lab",
    "icc_based",
    "separation",
    "device_n",
    "indexed",
    "pattern",
    (char*)NULL
};
const HPDF_ColorSpace optionColorSpaceEnum[] = {
    HPDF_CS_DEVICE_GRAY,
    HPDF_CS_DEVICE_RGB,
    HPDF_CS_DEVICE_CMYK,
    HPDF_CS_CAL_GRAY,
    HPDF_CS_CAL_RGB,
    HPDF_CS_LAB,
    HPDF_CS_ICC_BASED,
    HPDF_CS_SEPARATION,
    HPDF_CS_DEVICE_N,
    HPDF_CS_INDEXED,
    HPDF_CS_PATTERN
};

const char *optionColorSpaceForRawString[] = {
    "gray",
    "rgb",
    "cmyk",
    (char*)NULL
};
const HPDF_ColorSpace optionColorSpaceForRawEnum[] = {
    HPDF_CS_DEVICE_GRAY,
    HPDF_CS_DEVICE_RGB,
    HPDF_CS_DEVICE_CMYK,
};


const char *optionLineCapString[] = {
    "butt_end",
    "round_end",
    "projecting_scuare_end",
    (char*)NULL
};
const HPDF_LineCap optionLineCapEnum[] = {
    HPDF_BUTT_END,
    HPDF_ROUND_END,
    HPDF_PROJECTING_SCUARE_END
};

const char *optionLineJoinString[] = {
    "miter_join",
    "round_join",
    "bevel_join",
    (char*)NULL
};
const HPDF_LineJoin optionLineJoinEnum[] = {
    HPDF_MITER_JOIN,
    HPDF_ROUND_JOIN,
    HPDF_BEVEL_JOIN,
};


const char *optionTextRenderingModeString[] = {
    "fill",
    "stroke",
    "fill_then_stroke",
    "invisible",
    "fill_clipping",
    "stroke_clipping",
    "fill_stroke_clipping",
    "clipping",
    (char*)NULL
};
const HPDF_TextRenderingMode optionTextRenderingModeEnum[] = {
    HPDF_FILL,
    HPDF_STROKE,
    HPDF_FILL_THEN_STROKE,
    HPDF_INVISIBLE,
    HPDF_FILL_CLIPPING,
    HPDF_STROKE_CLIPPING,
    HPDF_FILL_STROKE_CLIPPING,
    HPDF_CLIPPING
};


const char *optionWritingModeString[] = {
    "horizontal",
    "vertical",
    (char*)NULL
};
const HPDF_WritingMode optionWritingModeEnum[] = {
    HPDF_WMODE_HORIZONTAL,
    HPDF_WMODE_VERTICAL
};


const char *optionPageLayoutString[] = {
    "single",
    "one_column",
    "two_column_left",
    "two_column_right",
    (char*)NULL
};
const HPDF_PageLayout optionPageLayoutEnum[] = {
    HPDF_PAGE_LAYOUT_SINGLE,
    HPDF_PAGE_LAYOUT_ONE_COLUMN,
    HPDF_PAGE_LAYOUT_TWO_COLUMN_LEFT,
    HPDF_PAGE_LAYOUT_TWO_COLUMN_RIGHT,
};


const char *optionPageModeString[] = {
    "none",
    "outline",
    "thumbs",
    "fullscreen",
/*    "oc",*/
/*    "attachments", */
    (char*)NULL
};
const HPDF_PageMode optionPageModeEnum[] = {
    HPDF_PAGE_MODE_USE_NONE,
    HPDF_PAGE_MODE_USE_OUTLINE,
    HPDF_PAGE_MODE_USE_THUMBS,
    HPDF_PAGE_MODE_FULL_SCREEN,
/*    HPDF_PAGE_MODE_USE_OC,*/
/*    HPDF_PAGE_MODE_USE_ATTACHMENTS, */
};


const char *optionPageNumStyleString[] = {
    "decimal",
    "upper_roman",
    "lower_roman",
    "upper_letters",
    "lower_letters",
    (char*)NULL
};
const HPDF_PageNumStyle optionPageNumStyleEnum[] = {
    HPDF_PAGE_NUM_STYLE_DECIMAL,
    HPDF_PAGE_NUM_STYLE_UPPER_ROMAN,
    HPDF_PAGE_NUM_STYLE_LOWER_ROMAN,
    HPDF_PAGE_NUM_STYLE_UPPER_LETTERS,
    HPDF_PAGE_NUM_STYLE_LOWER_LETTERS,
};


const char *optionDestinationTypeString[] = {
    "xyz",
    "fit",
    "fit_h",
    "fit_v",
    "fit_r",
    "fit_b",
    "fit_bh",
    "fit_bv",
    (char*)NULL
};
const HPDF_DestinationType optionDestinationTypeEnum[] = {
    HPDF_XYZ,
    HPDF_FIT,
    HPDF_FIT_H,
    HPDF_FIT_V,
    HPDF_FIT_R,
    HPDF_FIT_B,
    HPDF_FIT_BH,
    HPDF_FIT_BV
};

const char *optionAnnotTypeString[] = {
    "text_notes",
    "link",
    "sound",
    "free_text",
    "stamp",
    "square",
    "circle",
    "strike_out",
    "hightlight",
    "underline",
    "ink",
    "file_attachment",
    "popup",
    (char*)NULL

};
const HPDF_AnnotType optionAnnotTypeEnum[] = {
    HPDF_ANNOT_TEXT_NOTES,
    HPDF_ANNOT_LINK,
    HPDF_ANNOT_SOUND,
    HPDF_ANNOT_FREE_TEXT,
    HPDF_ANNOT_STAMP,
    HPDF_ANNOT_SQUARE,
    HPDF_ANNOT_CIRCLE,
    HPDF_ANNOT_STRIKE_OUT,
    HPDF_ANNOT_HIGHTLIGHT,
    HPDF_ANNOT_UNDERLINE,
    HPDF_ANNOT_INK,
    HPDF_ANNOT_FILE_ATTACHMENT,
    HPDF_ANNOT_POPUP
};


const char *optionAnnotFlgsString[] = {
    "invisible",
    "hidden",
    "print",
    "nozoom",
    "norotate",
    "noview",
    "readonly",
    (char*)NULL
};
const HPDF_AnnotFlgs optionAnnotFlgsEnum[] = {
    HPDF_ANNOT_INVISIBLE,
    HPDF_ANNOT_HIDDEN,
    HPDF_ANNOT_PRINT,
    HPDF_ANNOT_NOZOOM,
    HPDF_ANNOT_NOROTATE,
    HPDF_ANNOT_NOVIEW,
    HPDF_ANNOT_READONLY
};


const char *optionAnnotHighlightModeString[] = {
    "no_hightlight",
    "invert_box",
    "invert_border",
    "down_appearance",
    (char*)NULL
};
const HPDF_AnnotHighlightMode optionAnnotHighlightModeEnum[] = {
    HPDF_ANNOT_NO_HIGHTLIGHT,
    HPDF_ANNOT_INVERT_BOX,
    HPDF_ANNOT_INVERT_BORDER,
    HPDF_ANNOT_DOWN_APPEARANCE
};


const char *optionAnnotIconString[] = {
    "comment",
    "key",
    "note",
    "help",
    "new_paragraph",
    "paragraph",
    "insert",
    (char*)NULL
};
const HPDF_AnnotIcon optionAnnotIconEnum[] = {
    HPDF_ANNOT_ICON_COMMENT,
    HPDF_ANNOT_ICON_KEY,
    HPDF_ANNOT_ICON_NOTE,
    HPDF_ANNOT_ICON_HELP,
    HPDF_ANNOT_ICON_NEW_PARAGRAPH,
    HPDF_ANNOT_ICON_PARAGRAPH,
    HPDF_ANNOT_ICON_INSERT
};


const char *optionBSSubtypeString[] = {
    "solid",
    "dashed",
    "beveled",
    "inset",
    "underlined",
    (char*)NULL
};
const HPDF_BSSubtype optionBSSubtypeEnum[] = {
    HPDF_BS_SOLID,
    HPDF_BS_DASHED,
    HPDF_BS_BEVELED,
    HPDF_BS_INSET,
    HPDF_BS_UNDERLINED
};


const char *optionBlendModeString[] = {
    "normal",
    "multiply",
    "screen",
    "overlay",
    "darken",
    "lighten",
    "color_dodge",
    "color_bum",
    "hard_light",
    "soft_light",
    "difference",
    "exclushon",
    (char*)NULL
};
const HPDF_BlendMode optionBlendModeEnum[] = {
    HPDF_BM_NORMAL,
    HPDF_BM_MULTIPLY,
    HPDF_BM_SCREEN,
    HPDF_BM_OVERLAY,
    HPDF_BM_DARKEN,
    HPDF_BM_LIGHTEN,
    HPDF_BM_COLOR_DODGE,
    HPDF_BM_COLOR_BUM,
    HPDF_BM_HARD_LIGHT,
    HPDF_BM_SOFT_LIGHT,
    HPDF_BM_DIFFERENCE,
    HPDF_BM_EXCLUSHON
};


const char *optionTransitionStyleString[] = {
    "wipe_right",
    "wipe_up",
    "wipe_left",
    "wipe_down",
    "barn_doors_horizontal_out",
    "barn_doors_horizontal_in",
    "barn_doors_vertical_out",
    "barn_doors_vertical_in",
    "box_out",
    "box_in",
    "blinds_horizontal",
    "blinds_vertical",
    "dissolve",
    "glitter_right",
    "glitter_down",
    "glitter_top_left_to_bottom_right",
    "replace",
    (char*)NULL
};
const HPDF_TransitionStyle optionTransitionStyleEnum[] = {
    HPDF_TS_WIPE_RIGHT,
    HPDF_TS_WIPE_UP,
    HPDF_TS_WIPE_LEFT,
    HPDF_TS_WIPE_DOWN,
    HPDF_TS_BARN_DOORS_HORIZONTAL_OUT,
    HPDF_TS_BARN_DOORS_HORIZONTAL_IN,
    HPDF_TS_BARN_DOORS_VERTICAL_OUT,
    HPDF_TS_BARN_DOORS_VERTICAL_IN,
    HPDF_TS_BOX_OUT,
    HPDF_TS_BOX_IN,
    HPDF_TS_BLINDS_HORIZONTAL,
    HPDF_TS_BLINDS_VERTICAL,
    HPDF_TS_DISSOLVE,
    HPDF_TS_GLITTER_RIGHT,
    HPDF_TS_GLITTER_DOWN,
    HPDF_TS_GLITTER_TOP_LEFT_TO_BOTTOM_RIGHT,
    HPDF_TS_REPLACE
};


const char *optionPageSizesString[] = {
    "letter",
    "legal",
    "a3",
    "a4",
    "a5",
    "b4",
    "b5",
    "executive",
    "us4x6",
    "us4x8",
    "us5x7",
    "comm10",
    (char*)NULL
};
const HPDF_PageSizes optionPageSizesEnum[] = {
    HPDF_PAGE_SIZE_LETTER,
    HPDF_PAGE_SIZE_LEGAL,
    HPDF_PAGE_SIZE_A3,
    HPDF_PAGE_SIZE_A4,
    HPDF_PAGE_SIZE_A5,
    HPDF_PAGE_SIZE_B4,
    HPDF_PAGE_SIZE_B5,
    HPDF_PAGE_SIZE_EXECUTIVE,
    HPDF_PAGE_SIZE_US4x6,
    HPDF_PAGE_SIZE_US4x8,
    HPDF_PAGE_SIZE_US5x7,
    HPDF_PAGE_SIZE_COMM10
};


const char *optionPageDirectionString[] = {
    "portrait",
    "landscape",
    (char*)NULL
};
const HPDF_PageDirection optionPageDirectionEnum[] = {
    HPDF_PAGE_PORTRAIT,
    HPDF_PAGE_LANDSCAPE
};


const char *optionEncoderTypeString[] = {
    "single_byte",
    "double_byte",
    "uninitialized",
    "unknown",
    (char*)NULL
};
const HPDF_EncoderType optionEncoderTypeEnum[] = {
    HPDF_ENCODER_TYPE_SINGLE_BYTE,
    HPDF_ENCODER_TYPE_DOUBLE_BYTE,
    HPDF_ENCODER_TYPE_UNINITIALIZED,
    HPDF_ENCODER_UNKNOWN
};

const char *optionByteTypeString[] = {
    "single",
    "lead",
    "trial",
    "unknown",
    (char*)NULL
};
const HPDF_ByteType optionByteTypeEnum[] = {
    HPDF_BYTE_TYPE_SINGLE,
    HPDF_BYTE_TYPE_LEAD,
    HPDF_BYTE_TYPE_TRIAL,
    HPDF_BYTE_TYPE_UNKNOWN
};


const char *optionTextAlignmentString[] = {
    "left",
    "right",
    "center",
    "justify",
    (char*)NULL
};
const HPDF_TextAlignment optionTextAlignmentEnum[] = {
    HPDF_TALIGN_LEFT,
    HPDF_TALIGN_RIGHT,
    HPDF_TALIGN_CENTER,
    HPDF_TALIGN_JUSTIFY
};


int hpdf_getStringObjFromEnum (Tcl_Interp *interp,
        const char *strings[], const int enums[],
        int val, Tcl_Obj **result)
{
    int i = 0;
    while (strings[i] != NULL) {
        if (enums[i] == val) {
            *result = Tcl_NewStringObj(strings[i], -1);
            return TCL_OK;
        }
        i++;
    }
    *result = NULL;
    return TCL_ERROR;
}
int hpdf_getEnumFromStringObj (Tcl_Interp *interp,
        const char *strings[], const int enums[],
        Tcl_Obj *val, int *result)
{
    int i;
    if (Tcl_GetIndexFromObj(interp, val, 
                strings, "parameter", 0, &i) != TCL_OK) {
        return TCL_ERROR;
    }
    *result = enums[i];
    return TCL_OK;
}

int hpdf_getListObjFromFlags (Tcl_Interp *interp,
        const char *strings[], const int enums[],
        int val, Tcl_Obj **result)
{
    int i = 0;
    Tcl_Obj *listObj;
    listObj = Tcl_NewListObj(0, NULL);

    while (strings[i] != NULL) {
        if (enums[i] & val) {
            if (Tcl_ListObjAppendElement(interp, listObj, 
                        Tcl_NewStringObj(strings[i], -1)) != TCL_OK) {
                return TCL_ERROR;
            }
        }
        i++;
    }
    *result = listObj;
    return TCL_OK;
}

int hpdf_getFlagsFromListObj (Tcl_Interp *interp,
        const char *strings[], const int enums[],
        Tcl_Obj *listObj, int *result)
{
    int i;
    int len;
    int flag = 0;

    if (Tcl_ListObjLength(interp, listObj, &len) != TCL_OK) {
        return TCL_ERROR;
    }
    for (i = 0; i<len; i++) {
        Tcl_Obj *obj;
        int optionindex;
        if (Tcl_ListObjIndex(interp, listObj, i, &obj) != TCL_OK) {
            return TCL_ERROR;
        }
        if (Tcl_GetIndexFromObj(interp, obj,
                    strings, "flags", 0, &optionindex) != TCL_OK) {
            return TCL_ERROR;
        }
        flag |= enums[optionindex];
    }
    *result = flag;
    return TCL_OK;
}
