#include <hpdf_error.h>

const char *
hpdf_getErrorMessage (HPDF_STATUS error)
{
  switch (error) {
      case HPDF_ARRAY_COUNT_ERR:return "hpdf array count err";
      case HPDF_ARRAY_ITEM_NOT_FOUND:return "hpdf array item not found";
      case HPDF_ARRAY_ITEM_UNEXPECTED_TYPE:return "hpdf array item unexpected type";
      case HPDF_BINARY_LENGTH_ERR:return "hpdf binary length err";
      case HPDF_CANNOT_GET_PALLET:return "hpdf cannot get pallet";
      case HPDF_DICT_COUNT_ERR:return "hpdf dict count err";
      case HPDF_DICT_ITEM_NOT_FOUND:return "hpdf dict item not found";
      case HPDF_DICT_ITEM_UNEXPECTED_TYPE:return "hpdf dict item unexpected type";
      case HPDF_DICT_STREAM_LENGTH_NOT_FOUND:return "hpdf dict stream length not found";
      case HPDF_DOC_ENCRYPTDICT_NOT_FOUND:return "hpdf doc encryptdict not found";
      case HPDF_DOC_INVALID_OBJECT:return "hpdf doc invalid object";
      case HPDF_DUPLICATE_REGISTRATION:return "hpdf duplicate registration";
      case HPDF_EXCEED_JWW_CODE_NUM_LIMIT:return "hpdf exceed jww code num limit";
      case HPDF_ENCRYPT_INVALID_PASSWORD:return "hpdf encrypt invalid password";
      case HPDF_ERR_UNKNOWN_CLASS:return "hpdf err unknown class";
      case HPDF_EXCEED_GSTATE_LIMIT:return "hpdf exceed gstate limit";
      case HPDF_FAILD_TO_ALLOC_MEM:return "hpdf faild to alloc mem";
      case HPDF_FILE_IO_ERROR:return "hpdf file io error";
      case HPDF_FILE_OPEN_ERROR:return "hpdf file open error";
      case HPDF_FONT_EXISTS:return "hpdf font exists";
      case HPDF_FONT_INVALID_WIDTHS_TABLE:return "hpdf font invalid widths table";
      case HPDF_INVALID_AFM_HEADER:return "hpdf invalid afm header";
      case HPDF_INVALID_ANNOTATION:return "hpdf invalid annotation";
      case HPDF_INVALID_BIT_PER_COMPONENT:return "hpdf invalid bit per component";
      case HPDF_INVALID_CHAR_MATRICS_DATA:return "hpdf invalid char matrics data";
      case HPDF_INVALID_COLOR_SPACE:return "hpdf invalid color space";
      case HPDF_INVALID_COMPRESSION_MODE:return "hpdf invalid compression mode";
      case HPDF_INVALID_DATE_TIME:return "hpdf invalid date time";
      case HPDF_INVALID_DESTINATION:return "hpdf invalid destination";
      case HPDF_INVALID_DOCUMENT:return "hpdf invalid document";
      case HPDF_INVALID_DOCUMENT_STATE:return "hpdf invalid document state";
      case HPDF_INVALID_ENCODER:return "hpdf invalid encoder";
      case HPDF_INVALID_ENCODER_TYPE:return "hpdf invalid encoder type";
      case HPDF_INVALID_ENCODING_NAME:return "hpdf invalid encoding name";
      case HPDF_INVALID_ENCRYPT_KEY_LEN:return "hpdf invalid encrypt key len";
      case HPDF_INVALID_FONTDEF_DATA:return "hpdf invalid fontdef data";
      case HPDF_INVALID_FONTDEF_TYPE:return "hpdf invalid fontdef type";
      case HPDF_INVALID_FONT_NAME:return "hpdf invalid font name";
      case HPDF_INVALID_IMAGE:return "hpdf invalid image";
      case HPDF_INVALID_JPEG_DATA:return "hpdf invalid jpeg data";
      case HPDF_INVALID_N_DATA:return "hpdf invalid n data";
      case HPDF_INVALID_OBJECT:return "hpdf invalid object";
      case HPDF_INVALID_OBJ_ID:return "hpdf invalid obj id";
      case HPDF_INVALID_OPERATION:return "hpdf invalid operation";
      case HPDF_INVALID_OUTLINE:return "hpdf invalid outline";
      case HPDF_INVALID_PAGE:return "hpdf invalid page";
      case HPDF_INVALID_PAGES:return "hpdf invalid pages";
      case HPDF_INVALID_PARAMETER:return "hpdf invalid parameter";
      case HPDF_INVALID_PNG_IMAGE:return "hpdf invalid png image";
      case HPDF_INVALID_STREAM:return "hpdf invalid stream";
      case HPDF_MISSING_FILE_NAME_ENTRY:return "hpdf missing file name entry";
      case HPDF_INVALID_TTC_FILE:return "hpdf invalid ttc file";
      case HPDF_INVALID_TTC_INDEX:return "hpdf invalid ttc index";
      case HPDF_INVALID_WX_DATA:return "hpdf invalid wx data";
      case HPDF_ITEM_NOT_FOUND:return "hpdf item not found";
      case HPDF_LIBPNG_ERROR:return "hpdf libpng error";
      case HPDF_NAME_INVALID_VALUE:return "hpdf name invalid value";
      case HPDF_NAME_OUT_OF_RANGE:return "hpdf name out of range";
      case HPDF_PAGE_INVALID_PARAM_COUNT:return "hpdf page invalid param count";
      case HPDF_PAGES_MISSING_KIDS_ENTRY:return "hpdf pages missing kids entry";
      case HPDF_PAGE_CANNOT_FIND_OBJECT:return "hpdf page cannot find object";
      case HPDF_PAGE_CANNOT_GET_ROOT_PAGES:return "hpdf page cannot get root pages";
      case HPDF_PAGE_CANNOT_RESTORE_GSTATE:return "hpdf page cannot restore gstate";
      case HPDF_PAGE_CANNOT_SET_PARENT:return "hpdf page cannot set parent";
      case HPDF_PAGE_FONT_NOT_FOUND:return "hpdf page font not found";
      case HPDF_PAGE_INVALID_FONT:return "hpdf page invalid font";
      case HPDF_PAGE_INVALID_FONT_SIZE:return "hpdf page invalid font size";
      case HPDF_PAGE_INVALID_GMODE:return "hpdf page invalid gmode";
      case HPDF_PAGE_INVALID_INDEX:return "hpdf page invalid index";
      case HPDF_PAGE_INVALID_ROTATE_VALUE:return "hpdf page invalid rotate value";
      case HPDF_PAGE_INVALID_SIZE:return "hpdf page invalid size";
      case HPDF_PAGE_INVALID_XOBJECT:return "hpdf page invalid xobject";
      case HPDF_PAGE_OUT_OF_RANGE:return "hpdf page out of range";
      case HPDF_REAL_OUT_OF_RANGE:return "hpdf real out of range";
      case HPDF_STREAM_EOF:return "hpdf stream eof";
      case HPDF_STREAM_READLN_CONTINUE:return "hpdf stream readln continue";
      case HPDF_STRING_OUT_OF_RANGE:return "hpdf string out of range";
      case HPDF_THIS_FUNC_WAS_SKIPPED:return "hpdf this func was skipped";
      case HPDF_TTF_CANNOT_EMBEDDING_FONT:return "hpdf ttf cannot embedding font";
      case HPDF_TTF_INVALID_CMAP:return "hpdf ttf invalid cmap";
      case HPDF_TTF_INVALID_FOMAT:return "hpdf ttf invalid fomat";
      case HPDF_TTF_MISSING_TABLE:return "hpdf ttf missing table";
      case HPDF_UNSUPPORTED_FONT_TYPE:return "hpdf unsupported font type";
      case HPDF_UNSUPPORTED_FUNC:return "hpdf unsupported func";
      case HPDF_UNSUPPORTED_JPEG_FORMAT:return "hpdf unsupported jpeg format";
      case HPDF_UNSUPPORTED_TYPE1_FONT:return "hpdf unsupported type1 font";
      case HPDF_XREF_COUNT_ERR:return "hpdf xref count err";
      case HPDF_ZLIB_ERROR:return "hpdf zlib error";
      case HPDF_INVALID_PAGE_INDEX:return "hpdf invalid page index";
      case HPDF_INVALID_URI:return "hpdf invalid uri";
      case HPDF_PAGE_LAYOUT_OUT_OF_RANGE:return "hpdf page layout out of range";
      case HPDF_PAGE_MODE_OUT_OF_RANGE:return "hpdf page mode out of range";
      case HPDF_PAGE_NUM_STYLE_OUT_OF_RANGE:return "hpdf page num style out of range";
      case HPDF_ANNOT_INVALID_ICON:return "hpdf annot invalid icon";
      case HPDF_ANNOT_INVALID_BORDER_STYLE:return "hpdf annot invalid border style";
      case HPDF_PAGE_INVALID_DIRECTION:return "hpdf page invalid direction";
      case HPDF_INVALID_FONT:return "hpdf invalid font";
      case HPDF_PAGE_INSUFFICIENT_SPACE:return "hpdf page insufficient space";
      case HPDF_PAGE_INVALID_DISPLAY_TIME:return "hpdf page invalid display time";
      case HPDF_PAGE_INVALID_TRANSITION_TIME:return "hpdf page invalid transition time";
      case HPDF_INVALID_PAGE_SLIDESHOW_TYPE:return "hpdf invalid page slideshow type";
      case HPDF_EXT_GSTATE_OUT_OF_RANGE:return "hpdf ext gstate out of range";
      case HPDF_INVALID_EXT_GSTATE:return "hpdf invalid ext gstate";
      case HPDF_EXT_GSTATE_READ_ONLY:return "hpdf ext gstate read only";
      default: return "unknown error code";
  }
}
